/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Decodieren.h"

# ifndef DECODIEREN_CPP
# define DECODIEREN_CPP


Decodieren::Decodieren (QWidget *parent,QString versionsnummer)
{
    if(debuglevel>=2)
    {
        cout<<" * Konstructor : Decodieren *"<<endl<<endl;
    }

    // Speichert das Eltern Widget ab
    eltern=parent;

    // Uebergeben Version ablegen
    version=versionsnummer;

    // Rezeugt das ein Timerobjekt fuer das herunterfahren
    timer=new QTimer(eltern);
    connect(timer, SIGNAL(timeout()),this,SLOT(herunterfahren()));

    // Damit als erster der erste String beschrieben wird
    stringvar=0;
    durchlauf=0;

    // Laet die Gespeicherten Einstellungen
    laden();

    // Standart werte zuweisen
    startzeit="00:00:00";
    endzeit  ="00:00:00";

}

void Decodieren::decodieren (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : Decodieren *"<<endl<<endl;
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Fildialogs noetig)
    zerlegt_outfilename = outfilename;

    // String kontrolliern ob er Lerrzeichen enthaelt und dies fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(zerlegt_outfilename);

    // Kontrolle ob der letzte Dateinamen auch so geheissen hat
    if(durchlauf>0)
    {
        if(zerlegt_outfilename==ausgabenamen[durchlauf-1])
        {
            // das z kuerzel bei den Fieldialog hinzufuegen
            zerlegt_outfilename=ausgabenamen[durchlauf-1]+".z";

            // das z kuerzel bei den Ordnernamen hinzufuegen damit die naechste kontrolle der Dateinamen nicht fehl schlaegt
            outfilename+=".z";
        }
    }

    // Stellt den Ausgabestring zusammen
    tempausgabe="mencoder dvd://"+titelnummer+" -dvd-device "+zerlegt_indirname;

    // Kontrolle ob der Anfang weggeschnitten werden muss
    if(boolstartzeit==true)
    {
        tempausgabe+=" -ss "+startzeit;
    }

    // Kontrolle ob das Ende weggeschnitten werden muss
    if(boolendzeit==true)
    {
        tempausgabe+=" -endpos "+endzeit;
    }

    // Wenn alang nicht "St" ist dann decodiere mit den vorhanden Untertiteln
    if(!(alang=="St"))
    {
        tempausgabe+=" -alang "+alang;
    }

    // Wenn die Untertitelnummer nicht "ln" ist dann fuege Untertitel hinzu
    if(!(untertitelnummer=="-1"))
    {
        tempausgabe+=" -sid "+untertitelnummer;
    }
    tempausgabe+=" -oac "+audioopt+" -ovc xvid -xvidencopts bitrate="+bitrateopt;

    // Kontrolle ob "boolcartoon" wahr ist um die entsperchende Option einzufuegen
    if(boolcartoon==true)
    {
        tempausgabe+=":cartoon";
    }

    // Kontrolle ob "boolautoapect" wahr ist um die entsperchende Option einzufuegen
    if(boolautoaspect==true)
    {
        tempausgabe+=":autoaspect";
    }

    // Kontrolle ob "bool2pass" wahr ist um die entsperchende Option einzufuegen
    if(bool2pass==true)
    {
        tempausgabe+=":pass=1";
    }

    // Schliesst den Ausgabestream ab
    tempausgabe+=" -o "+zerlegt_outfilename;

    //  Den zusammengestellten String dem "ausgabestring" zuweisen
    ausgabe[stringvar]=tempausgabe;

    // Damit wenn zusammegfuegt werden soll alle Namen bekannt sind
    ausgabenamen[durchlauf]=zerlegt_outfilename;

    //damit als naehstes der andere string beschrieben wird
    stringvar++;
    durchlauf++;

    // Wenn 2Pass gesetzt ist muss  eine 2Decodierung durchgefuert werdenund das Erfolgt mit diesen Zusatz
    if(bool2pass==true)
    {
        tempausgabe="mencoder dvd://"+titelnummer+" -dvd-device "+zerlegt_indirname;

        // Kontrolle ob der Anfang weggeschnitten werden muss
        if(boolstartzeit==true)
        {
            tempausgabe+=" -ss "+startzeit;
        }

        // Kontrolle ob das Ende weggeschnitten werden muss
        if(boolendzeit==true)
        {
            tempausgabe+=" -endpos "+endzeit;
        }

        if(!(alang=="St"))
        {
            tempausgabe+=" -alang "+alang;
        }

        if(!(untertitelnummer=="-1"))
        {
            tempausgabe+=" -sid "+untertitelnummer;
        }

        tempausgabe+=" -oac "+audioopt+" -ovc xvid -xvidencopts bitrate="+bitrateopt;

        if(boolcartoon==true)
        {
            tempausgabe+=":cartoon";
        }

        if(boolautoaspect==true)
        {
            tempausgabe+=":autoaspect";
        }
        tempausgabe+=":pass=2";
        tempausgabe+=" -o "+zerlegt_outfilename;

        //  Den zusammengestellten String dem "ausgabestring" zuweisen
        ausgabe[stringvar]=tempausgabe;

        //damit als naehstes der andere string beschrieben wird
        stringvar++;
    }
}

void Decodieren::setindirname(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setindirname *"<<endl<<endl;
    }

    // Erstell den Filedialog
    QFileDialog *inname = new QFileDialog(eltern);

    // Oeffnet einen Dialog in dem man nur Ornder auswaehlen kann
    indirname=inname->getExistingDirectory(indirname,eltern);

    if(debuglevel==3)
    {
        cout<<" Eingabegabename = "<<indirname<<endl<<endl;
    }

    // Kontrolle on der Rueckgabe wert vom Filedialog nihct 0 ist
    if(indirname==NULL)
    {
        indirname="/";
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Fildialogs noetig)
    zerlegt_indirname   = indirname;

    // String kontrolliern ob er Leerzeichen enthaelt und dies fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(zerlegt_indirname);

    // Wenn ein neuer Eingaebordner ausgewaehlt wurde dann wird dieses Signal gesendet mit den Ordnerpfad
    emit ordnerausgewaehlt(zerlegt_indirname);
}

void Decodieren::set_indirname(QString name)
{
    //Weist nur den indrinamen zu
    zerlegt_indirname=name;

    // Wenn ein neuer Eingaebordner ausgewaehlt wurde dann wird dieses Signal gesendet mit den Ordnerpfad
    emit ordnerausgewaehlt(zerlegt_indirname);
}

void Decodieren::setoutname (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setoutname *"<<endl<<endl;
    }

    // Erstell den Filedialog
    QFileDialog *outname = new QFileDialog(eltern);

     // Oeffnet einen Dialog in dem man den Ort und den Dateinamen auswaehlen kann
    tempoutfilename=outname->getSaveFileName(outfilename,0,eltern);

    // Zur Kontrolle ob der zurueckgegeben Pfad auch etwas enthaelt
    if (!(tempoutfilename==0))
    {
        outfilename=tempoutfilename;
    }

    if(debuglevel==3)
    {
        cout<<" Ausgabename = "<<outfilename<<endl<<endl;
    }
}

void Decodieren::setcartoon (bool cartoon)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setcartoon *"<<endl<<endl;
    }

    // Weist der "boolcartoon" Variable den uebergeben Wert zu
    boolcartoon=cartoon;

    if(debuglevel==3)
    {
        cout<<" Cartoon Obtimierungs Wert = "<<boolcartoon<<endl<<endl;
    }
}

void Decodieren::set2pass (bool pass2)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : set2pass *"<<endl<<endl;
    }

    // Weist der "bool2pass" Variable den uebergeben Wert zu
    bool2pass=pass2;

    if(debuglevel==3)
    {
        cout<<" 2-Pass Decodierungs Wert = "<<bool2pass<<endl<<endl;
    }
}

void Decodieren::setautoaspect(bool autoaspect)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setautoaspect*"<<endl<<endl;
    }

    // Weist der "boolautoaspects" Variable den uebergeben Wert zu
    boolautoaspect=autoaspect;

    if(debuglevel==3)
    {
        cout<<" Autoaspect Options  Wert = "<<boolautoaspect<<endl<<endl;
    }
}

void Decodieren::setshutdown (bool shutdown)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setshutdown *"<<endl<<endl;
    }

    // Weist der "bool2pass" Variable den uebergeben Wert zu
    boolshutdown=shutdown;

    if(debuglevel==3)
    {
        cout<<" Schutdown Wert = "<<boolshutdown<<endl<<endl;
    }
}

void Decodieren::setauidoopt (const QString& audio)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setaudioopt *"<<endl<<endl;
    }

    // Weist der "audiopt" Variable den uebergeben Audiooptionswert zu
    audioopt=audio;

    if(debuglevel==3)
    {
        cout<<" Audio Optionen ausgewaehlt = "<<audioopt<<endl<<endl;
    }
}

void Decodieren::setbitrateopt (const QString& bitrate)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setbitrateopt *"<<endl<<endl;
    }

    // Weist der "bitrateopt" Variable den uebergeben Bitratewert zu
    bitrateopt=bitrate;

    if(debuglevel==3)
    {
        cout<<" Bitrate Wert ausgewaehlt = "<<bitrate<<endl<<endl;
    }
}

void Decodieren::settitel (int titel)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : settitel *"<<endl<<endl;
    }

    // Weist der "titelnummert" Variable den uebergeben Wert zu
    titelnummer.setNum(titel+1);

    emit  titelausgewaehlt(titelnummer);

    if(debuglevel==3)
    {
        cout<<" Titelnummer ausgewaehlt = "<<titelnummer<<endl<<endl;
    }
}

void Decodieren::setmountpfad (QString mount)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setmountpfad *"<<endl<<endl;
    }

    // Weist der "mountpfad" Variable den uebergeben Wert zu
    mountpfad=mount;

    if(debuglevel==3)
    {
        cout<<" Mountpfad geaendert = "<<mountpfad<<endl<<endl;
    }
}

void Decodieren::setaudio (const QString& audio)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setaudio *"<<endl<<endl;
    }

    // Weist der "alang" Variable den uebergeben Wert zu
    alang=audio.left(2);

    if(debuglevel==3)
    {
        cout<<" Audiospur ausgewaehlt = "<<alang<<endl<<endl;
    }
}

void Decodieren::setuntertitel (const QString& untertitel)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setuntertitel *"<<endl<<endl;
    }

    // Weist der "untertitelnummer" Variable den uebergeben Wert zu
    untertitelnummer=untertitel.mid(2,1);

    // Untertitelnummer wird in ein Short Variable umgewandelt damit man 1 abziehen kann 
    umwandeln=untertitelnummer.toShort();

    // Zieht Umwandeln 1 ab da mplayer von 0 weg beginnt und nicht von 1
    umwandeln-=1;

    // Die um 1 verringerte Zahl "untertitelnummer" wieder zuweisen
    untertitelnummer.setNum(umwandeln);

    if(debuglevel==3)
    {
        cout<<" Untertitel ausgewaehlt = "<<untertitelnummer<<endl<<endl;
        cout<<" Temporaere umwandlungszahl = "<<umwandeln<<endl<<endl;
    }
}

void Decodieren::setdebug (int auswahl)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setdebug *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable zugewiesne und setzt den Debuglevel
    debuglevel=auswahl;

    // denn Debuglevel auch nach Einstellen speicheren
    einstellungen.debuglevel = auswahl;

    if(debuglevel==3)
    {
        cout<<" debuglevel variable = "<<debuglevel<<endl<<endl;
    }


}

void Decodieren::setbooleject (bool eject)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setbooleject *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolunmount"zugewiesen
    booleject=eject;

    if(debuglevel==3)
    {
        cout<<" boolecejt variable = "<<booleject<<endl<<endl;
    }
}

void Decodieren::setboolunmount (bool unmount)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setunmount *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolunmount"zugewiesen
    boolunmount=unmount;

    if(debuglevel==3)
    {
        cout<<" boolunmount variable = "<<boolunmount<<endl<<endl;
    }
}

void Decodieren::setzusammenfuegen (bool zusammenfuegen)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setzusammenfuegen *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolzusammenfuegen"zugewiesen
    boolzusammenfuegen=zusammenfuegen;

    if(debuglevel==3)
    {
        cout<<" boolzusammnefuegn variable = "<<boolzusammenfuegen<<endl<<endl;
    }
}

void Decodieren::setpart (bool part)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setpart *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "boolzusammenfuegen"zugewiesen
    boolpart=part;

    if(debuglevel==3)
    {
        cout<<" boolpart variable = "<<boolpart<<endl<<endl;
    }
}

void Decodieren::setsprache (QString neuesprache)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setsprache *"<<endl<<endl;
    }

    // Der Uebergeben wert wird der Variable "sprache"zugewiesen
    sprache=neuesprache;

    if(debuglevel==3)
    {
        cout<<" Sprachen variable = "<<boolpart<<endl<<endl;
    }
}

QString Decodieren::getindirname(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getindirname *"<<endl<<endl;
    }

    // damit der alte Pfad erhalten bleibt (fuer das Oeffne des Fildialogs noetig)
    zerlegt_indirname   = indirname;

    // String kontrolliern ob er Leerzeichen enthaelt und dies fuer die Konsole richtig aufbereiten
    neostring.string_zerlegen(zerlegt_indirname);

    return zerlegt_indirname;
}

QString Decodieren::getmountpfad (void)
{
    return mountpfad;
}

bool Decodieren::getcartoon(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getcartoon *"<<endl<<endl;
    }

    return boolcartoon;
}


bool Decodieren::get2pass(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : get2pass *"<<endl<<endl;
    }

    return bool2pass;
}

bool Decodieren::getautoaspect(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getautoaspect *"<<endl<<endl;
    }

    return boolautoaspect;
}

bool Decodieren::getshutdown(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getshutdown *"<<endl<<endl;
    }

    return boolshutdown;
}

QString Decodieren::getaudioopt(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getaudioopt *"<<endl<<endl;
    }

    return audioopt;
}

QString Decodieren::getbitrateopt(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getbitrate *"<<endl<<endl;
    }

    return bitrateopt;
}

bool Decodieren::getunmount(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getunmount *"<<endl<<endl;
    }

    return boolunmount;
}

bool Decodieren::geteject(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : geteject *"<<endl<<endl;
    }

    return booleject;
}

bool Decodieren::getzusammenfuegen(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getzusammenfuegn *"<<endl<<endl;
    }

    return boolzusammenfuegen;
}

bool Decodieren::getpart(void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getpart *"<<endl<<endl;
    }

    return boolpart;
}

int Decodieren::getdebug (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getdebug *"<<endl<<endl;
    }

    return debuglevel;
}

QString Decodieren::getsprache (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : getsprache *"<<endl<<endl;
    }

    return sprache;
}

void Decodieren::ruecksetzen(void)
{
    // Alle Einstellungen auf die Standardwerte setzen und den Variablen zuweisen
    einstellungen.ruecksetzen();
    zuweisen();
}

void Decodieren::laden(void)
{
    // Die gespeicherten Einstellungen laden und den Variablen zuweisen
    einstellungen.laden((neostring.homepfad()+".dvd2xvid/"),version);
    zuweisen();

}

void Decodieren::zuweisen(void)
{
    // Weist die Werte aus Einstellungen den Varibalen zu
    indirname          = einstellungen.indirname;
    outfilename        = einstellungen.outfilename;
    boolcartoon        = einstellungen.boolcartoon;
    bool2pass          = einstellungen.bool2pass;
    boolautoaspect     = einstellungen.boolautoaspect;
    audioopt           = einstellungen.audioopt;
    bitrateopt         = einstellungen.bitrateopt;
    mountpfad          = einstellungen.mountpfad;
    debuglevel         = einstellungen.debuglevel;
    boolshutdown       = einstellungen.boolshutdown;
    boolunmount        = einstellungen.boolunmount;
    booleject          = einstellungen.booleject;
    boolzusammenfuegen = einstellungen.boolzusammenfuegen;
    boolpart           = einstellungen.boolpart;
    sprache            = einstellungen.sprache;
}

void Decodieren::speichern(void)
{
    // Weist die Werte aus Decodiern den Varibalen zu
    einstellungen.indirname          = indirname;
    einstellungen.outfilename        = outfilename;
    einstellungen.boolcartoon        = boolcartoon;
    einstellungen.bool2pass          = bool2pass;
    einstellungen.boolautoaspect     = boolautoaspect;
    einstellungen.audioopt           = audioopt;
    einstellungen.bitrateopt         = bitrateopt;
    einstellungen.mountpfad          = mountpfad;
    einstellungen.debuglevel         = debuglevel;
    einstellungen.boolshutdown       = boolshutdown;
    einstellungen.boolunmount        = boolunmount;
    einstellungen.booleject          = booleject;
    einstellungen.boolzusammenfuegen = boolzusammenfuegen;
    einstellungen.boolpart           = boolpart;
    einstellungen.sprache            = sprache;

    // Speichert die Einstellungen in die Confdatei
    einstellungen.speichern();
}

void Decodieren::vorschau(void)
{
    vorschaustring=" gmplayer dvd://"+titelnummer+" -dvd-device "+zerlegt_indirname;

    // Wenn alang nicht "St" ist dann decodiere mit den vorhanden Untertiteln
    if(!(alang=="St"))
    {
        vorschaustring+=" -alang "+alang;
    }

    // Wenn die Untertitelnummer nicht "ln" ist dann fuege Untertitel hinzu
    if(!(untertitelnummer=="-1"))
    {
        vorschaustring+=" -sid "+untertitelnummer;
    }

    // Damit man dem Aufruf auch sieht
    cout<<endl<<vorschaustring<<endl<<endl;

    // Vorschau ausfueren
    system(vorschaustring);

    // Ausgabesting leeren
    vorschaustring="";
}

void Decodieren::starten(void)
{
    // Hauptfenster unsichtbar machen
    emit verstecken();

    // Damit alle Zeiten zuruckgesetz werden
    emit zeitfelderrucksetzen();

    // Nur Simuliertes schreiben keine wirkliche Decodierung wenn Debuglevel nicht 0 ist
    if(debuglevel>=1)
    {
        cout<<endl<<" Uebergabe an mencoder  = "<<endl;
        for(int zaehler=0;zaehler<stringvar;zaehler++)
        {
            cout<<zaehler+1<<".) "<<ausgabe[zaehler]<<endl;
        }
        cout<<endl;

        // Wenn die Decodierten Datein zusammengefuegt werden sollen dann fuere zusammenfuegen aus
        if(boolzusammenfuegen==true)
        {
            zusammenfuegen();
        }

        // kontrolliere ob die dvd nachher entbunden werden soll
        if(boolunmount==true)
        {
            cout<<" umount "<<mountpfad<<endl<<endl;

            // kontrolliere ob die dvd lade geoeffnetz werden soll
            if(booleject==true)
            {
                cout<<"eject "<<mountpfad<<endl<<endl;
            }
        }
        // Der Encodiervorgang ist abgeschlossen sende das Signal feritg
        emit fertig();
    }

    // Nur wenn DEBUG_1 LEVEL nicht gesetzt ist wir der Aufruf an Mencoder gehen und der Film konvertiert
    else
    {
        for(int zaehler=0;zaehler<stringvar;zaehler++)
        {
            // Damit man dem Aufruf auch sieht
            cout<<endl<<zaehler+1<<".)"<<ausgabe[zaehler];
            if(boolzusammenfuegen==true)
            {
                cout<<".part";
            }
            cout<<endl<<endl;

            if(boolzusammenfuegen==true)
            {
                // Startet den tatsaechlichen decodier vorgang
                system((ausgabe[zaehler]+=".part"));
            }
            else
            {
                // Startet den tatsaechlichen decodier vorgang
                system(ausgabe[zaehler]);
            }
        }

        // Wenn die Decodierten Datein zusammengefuegt werden sollen dann fuere zusammenfuegen aus
        if(boolzusammenfuegen==true)
        {
            zusammenfuegen();
        }

        // kontrolliere ob die dvd nachher entbunden werden soll
        if(boolunmount==true)
        {
            system(("umount "+mountpfad));

            // kontrolliere ob die dvd lade geoeffnetz werden soll
            if(booleject==true)
            {
                system(("eject "+mountpfad));
            }
        }

        // Der Decodiervorgang ist abgeschlossen sende das Signal feritg
        emit fertig();

        // Wenn boolshutdown aktiviert ist dan fahre das System herunter
        if(boolshutdown==true)
        {
            // Keinen Muell im System zuruecklassen
            system("rm /tmp/dvd2xvid");

            cout<<endl<<"      **********************************"<<endl;
            cout<<"      *  System wird herunetrgefahren !*"<<endl;
            cout<<"      **********************************"<<endl<<endl;
            timer->start(15000);
        }
    }

    var_reset();
}

void Decodieren::herunterfahren(void)
{
    // die Timer schleife auch wieder stoppen
    timer->stop();

    // Mit diesem Befehl wird der Computer herunter gefahren
    system("poweroff &");

    // Programm beenden
    emit runterfahren();
}

void Decodieren::anhaengen (void)
{
    if(durchlauf<=8)
    {
        // Die Endzeit Errechnen
        boolendzeit=neostring.zeitrechnen(startzeit,endzeit);

        // Zuerst einen Ausgabestring zusammenbauen
        decodieren();

        // Fuer die Anzeige in dem Stapelfenster
        emit aufruf(outfilename,titelnummer,boolcartoon,bool2pass,boolautoaspect);

        /*
        // Nur Simuliertes schreiben keine wirkliche Decodierung
        cout<<endl<<" In der Warteschlange  = "<<endl;
        for(int zaehler=0;zaehler<stringvar;zaehler++)
        {
            cout<<zaehler+1<<".) "<<ausgabe[zaehler];

            if(boolzusammenfuegen==true)
            {
                cout<<".part";
            }
            cout<<endl;
        }
        cout<<endl;*/

        // Damit alle Zeiten zuruckgesetz werden
        emit zeitfelderrucksetzen();
    }
    else
    {
        // Meldung ausgeben nicht mehr als zehn Auftraege gespeichert werden koennen 
        QMessageBox::critical(eltern,"Stapelverarbeitung","Maximale Auftragszahl erreicht",
                              QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
    }
}

void Decodieren::setstartzeit(const QString& zeit)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setstartzeit *"<<endl<<endl;
    }

    // Weist den uebergeben String der Varibale "startzeit" zu
    startzeit=zeit;

    // Kontrolle ob sich die Zeit ueberhaupt geandert hat
    if(!(zeit=="00:00:00"))
    {
        // Damit diese Option dann auch hinzugefuegt wird
        boolstartzeit=true;
    }
    else
    {
        // Damit diese Option nicht hinzugefuegt wird
        boolstartzeit=false;
    }

    if(debuglevel>=3)
    {
        cout<<" startzeit = "<<startzeit<<endl<<endl;
    }
}

void Decodieren::setendzeit(const QString& zeit)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : setendzeit *"<<endl<<endl;
    }

    // Weist den uebergeben String der Varibale "startzeit" zu
    endzeit=zeit;

    if(debuglevel>=3)
    {
        cout<<" endzeit = "<<endzeit<<endl<<endl;
    }
}

void Decodieren::zusammenfuegen (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : zusammenfuegen *"<<endl<<endl;
    }

    // Kontrolle ob Zusammen fuegen uberhaupt noetig ist
    if(stringvar>0)
    {
        // Aufruf fuer das zusammenfuegn zusammenabuen
        tempausgabe=" avimerge -i";

        for(int zaehler=0;zaehler<durchlauf;zaehler++)
        {
            tempausgabe+=" "+ausgabenamen[zaehler]+".part";
        }

        tempausgabe+=" -o "+ausgabenamen[0];

        // Ausgabe and die Standardausgabe
        cout<<endl<<" "<<tempausgabe<<endl<<endl;

        // Nur Simuliertes schreiben keine wirkliche Decodierung wenn Debuglevel nicht 0 ist
        if(debuglevel<1)
        {
            // Zusammenfuegen durch fuehren lassen
            system(tempausgabe);
            cout<<endl;
        }

        // Alle temporaeren part dateien loeschen wenn dies ausgewaehlt worden ist
        delpart();
    }
}

void Decodieren::delpart (void)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : delpart *"<<endl<<endl;
    }

    //Kontrolle ob die Datein wirklilch geloescht werden sollen
    if(boolpart==true)
    {
        // Aufruf fuer das loeschen der .part Datein zusammenabuen
        for(int zaehler=0;zaehler<durchlauf;zaehler++)
        {
            tempausgabe="rm "+ausgabenamen[zaehler]+".part";

            // Ausgabe and die Standardausgabe
            cout<<" "<<tempausgabe<<endl<<endl;

            if(debuglevel<1)
            {
                // Entsprechende Datei loeschen
                system(tempausgabe);
            }
        }
    }
}

void Decodieren::encodieren(void)
{
    // Die Endzeit Errechnen
    boolendzeit=neostring.zeitrechnen(startzeit,endzeit);

    // Zuerst einen Ausgabestring zusammenbauen
    decodieren();

    // Begint mit den Encodieren
    starten();
}

void Decodieren::var_reset(void)
{
    // Stringvar und durchlauf zuruecksetzen
    stringvar=0;
    durchlauf=0;
}
# endif
