/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


# ifndef DECODIEREN_H
# define DECODIEREN_H

# include <qobject.h>
# include <qwidget.h>
# include <qstring.h>
# include <qfiledialog.h>
# include <qtimer.h>
# include <qprocess.h>
# include <qmessagebox.h>

# include <cstdlib>                                   // Fuer system()
# include <iostream>

# include "Neostring.h"
# include "Einstellungen.h"

class Decodieren : public QObject
{
    Q_OBJECT

    private:
        QString indirname,                       // Pfad an dem das Quellmaterial liegt
                zerlegt_indirname,               // Pafd vom Quellmatreial aber aufberiete fuer Console
                outfilename,                     // Pfad und Name an dem die Fertige Datei hin soll
                tempoutfilename,                 // Zur Kontrolle ob der zurueckgegeben Pfad auch etwas enthaelt
                zerlegt_outfilename,             // Pafd von der Zieldatei aber aufberiete fuer Console
                audioopt,                        // Mit welchem Adiocodec decodiert werden soll
                bitrateopt,                      // Mit welcher Bitrate decodiert werden soll (beinflusst die Qualitaet)
                ausgabe[30],                     // darin wird die Ausgabe fuer den mencoder Aufruf zusammen gebaut
                tempausgabe,                     // Damit der Ausgabestring zwischengespeichert wird fuer Anhaengen
                vorschaustring,                  // Fuer den Ausgabe string bei der Vorschau
                titelnummer,                     // Welche Titelnummer der DVD decodiert werden sollen
                alang,                           // mit Welcher Sprache decodiert werden soll
                untertitelnummer,                // Mit Welchen Untertitel decodiert werden soll
                debugtemp,                       // Darin wird er Wert von der ComboBox gespeichert und dann umgewandelt
                startzeit,                       // Ab wann er Decodieren soll
                endzeit,                         // Bis wann er Decodiern soll
                ausgabenamen[30],                // Fuer zusammenfuegen, damit man die einzelnen datein nachher noch kennt
                mountpfad,                       // Der Ort wo die DVD's gemountet werden
                version,                         // Beinhaltet die Versionsnummer von dvd2xvid
                homepfad,                        // Beihnalte den hompfad des ausfuerne den Benutzers
                sprache;                         // Welche Sprache eingestellt ist

        bool boolcartoon,                        // Ob mit der Cartoon-Optimierung gearbeitet werden soll
             bool2pass,                          // Ob  der 2-Pass Modus aktiviert werden soll
             boolautoaspect,                     // Ob der Bildausschint  automatisch zurechtgeschnitten wird 
             boolshutdown,                       // Ob der Computer nach h er heruntergefahren werden soll
             boolstartzeit,                      // Konbtrolle ob diese Option ueberhaupt verwendet wird
             boolendzeit,                        // Konbtrolle ob diese Option ueberhaupt verwendet wird
             booleject,                          // Ob nach den Decodieren die Schublade geoefnnet werden soll
             boolunmount,                        // Ob nach den Decodieren die DVD mit unmount wieder entbunden werden soll
             boolzusammenfuegen,                 // Ob die Dateien nach den Decodieren zusammen gefuegt werden sollen
             boolpart;                           // Ob die part Datein beim zusammenfuegen nachher geloescht werden sollen

        short umwandeln,                         // zur kurzzeitigen ablage vom umgewandelten Wert der Integer Variable
              stringvar,                         // In welchen string geschreiben werden soll
              durchlauf;                         // Der wievielte Durchlauf es ist,also 2pass aufrufe werden nicht mit gezaehlt

        int debuglevel;                          // setzen des aktuellen Debuglevels

        QWidget *eltern;                         // Darin wird der Zeiger zum Elternwidget abgelegt
        QTimer  *timer;                          // Ein Timer Objekt fuer das Verzoegern des Herunterfahrens


        Neostring neostring;                     // Wird fuer "sting_zerlegen" und "homepath" gebraucht

        Einstellungen einstellungen;             // Im Einstellungsobjekt sind die Standartwerte gespeichert

    public:

        Decodieren(QWidget *parent,QString versionsnummer);             // Konstruktor

    signals:

        // Wenn ein neuer Eingaebordner ausgewaehlt wurde dann wird dieses Signal gesendet mit den Ordnerpfad
        void ordnerausgewaehlt(QString);

        // Wenn ein nuer Titel ausgewaehlt wird dann werden die dazugehoerigen Tonund untertitel berrechnet
        void titelausgewaehlt(QString);

        // Damit die beid eDreier Fleder reuckgestzt werden
        void zeitfelderrucksetzen(void);

        // Sendet das Signal zum Schliessen des Programms
        void runterfahren (void);

        // Stellt alle Daten zusammen fuer die Stapelverabreitungsanzeige
        void aufruf(QString,QString,bool,bool,bool);

        // Wird gesendet wenn der Encodiervorgang zu Ende ist
        void fertig (void);

        // Die Fenster Unsichtbar machen
        void verstecken (void);

    public slots:

        // darin wird der Aufruf fuer mencoder zusammengestellt
        void decodieren (void);

        // Erstellt einen File-Dialog der nur Ornder anzeigt und darin soll dann der Quell-Ordner ausgewaehlt werden 
        void setindirname(void);

        //Weist nur den indrinamen zu
        void set_indirname(QString name);

        // Erstellt einen File-Dialog fuer die Auswahl eines Pfades fuer die Zeil-Datei 
        void setoutname (void);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolcartoon" zu
        void setcartoon (bool cartoon);

        // uebernimmt den Wert vom Aufrufer und weist ihm "bool2pass" zu
        void set2pass (bool pass2);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolautoaspect" zu
        void setautoaspect(bool autoaspect);

        // uebernimmt den Wert vom Aufrufer und weist ihm "audioopt" zu
        void setauidoopt (const QString& audio);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolshutdown" zu
        void setshutdown (bool shutdown);

        // uebernimmt den Wert vom Aufrufer und weist ihm "bitrateopt" zu
        void setbitrateopt (const QString& bitrate);

        // uebernimmt den Wert vom Aufrufer und weist ihm "titelnummer" zu
        void settitel (int titel);

        // uebernimmt den Wert vom Aufrufer und weist ihm "alang" zu
        void setaudio (const QString& audio);

        // uebernimmt den Wert vom Aufrufer und weist ihm "alang" zu
        void setuntertitel(const QString& untertitel);

        // uebernimmt den Wert vom Aufrufer und weist ihm "debuglevel" zu
        void setdebug(int auswahl);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolpart" zu
        void setpart (bool part);

        // uebernimmt den Wert vom Aufrufer und weist ihm "mountpfad" zu
        void setmountpfad (QString mount);

        // Den uebergeben wert "sprache zuweisen
        void setsprache (QString neuesprache);

        // Gibt den aufbereiteten indirnammen zurueck
        QString getindirname(void);

        // Giebt den Mount-Point der DVD zurueck
        QString getmountpfad (void);

        // Gibt denn Wert der "boolcartoon" Variable zurueck
        bool getcartoon(void);

        // Gibt denn Wert der "bool2pass" Variable zurueck
        bool get2pass(void);

        // Gibt denn Wert der "boolautoaspect" Variable zurueck
        bool getautoaspect(void);

        // Gibt denn Wert der "boolshutdown" Variable zurueck
        bool getshutdown(void);

        // Gibt denn Wert der "boolunmount" Variable zurueck
        bool getunmount (void);

        // Gibt denn Wert der "boolshutdown" Variable zurueck
        bool geteject (void);

        // Gibt denn Wert der "boolzusammenfugen" Variable zurueck
        bool getzusammenfuegen(void);

        // Gibt denn Wert der "boolpart" Variable zurueck
        bool getpart (void);

        // Gibt den Debuglevel wert zurueck
        int getdebug (void);

        // Gibt die momentane Sprache zurueck
        QString getsprache (void);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolunmount" zu
        void setboolunmount (bool unmount);

        // uebernimmt den Wert vom Aufrufer und weist ihm "booleject" zu
        void setbooleject (bool eject);

        // kontrolliert ob die Datein am Ende zusammne gefuegt werden sollen
        void setzusammenfuegen (bool zusammenfuegen);

        // Gibt denn Wert des "audioopt" Strings zurueck
        QString getaudioopt (void);

        // Gibt denn Wert des "bitrateopt" Strings zurueck
        QString getbitrateopt (void);

        // Setzt alle Einstellungen wieder zurueck
        void ruecksetzen(void);

        // Laedet alle Einstellungen
        void laden (void);

        // Speichert all einstellungen
        void speichern (void);

        // Weist die Werte aus Einstellungen den Varibalen zu
        void zuweisen (void);

        // Vorschau der bisherigen Einstellungen
        void vorschau (void);

        // Startet den Decodieren Aufruf
        void starten (void);

        // erstellt den String fuers anhaengen und gibt eine Meldung an die Console aus
        void anhaengen (void);

        // setzen der Startzeit 
        void setstartzeit(const QString& zeit);

        // setzen der Endzeit 
        void setendzeit(const QString& zeit);

        // Laesst das System herunterfahren
        void herunterfahren (void);

        // Soll das zusammen fuegen von fertigen Datein ermoeglichen
        void zusammenfuegen (void);

        // Soll die temporaeren ".part" Dateien loeschen
        void delpart (void);

        // Baut noch einen Aufruf zusammen und fuert dann starten() aus
        void encodieren(void);

        // Setzt die Durchlauf und  Stringvar Variblen zurueck
        void var_reset(void);
};

# endif
