/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef LSDVD_H
# define LSDVD_H

# include <qcombobox.h>
# include <qstring.h>

# include <cstdlib>                              // Fuer system()
# include <fstream>                              // Fuer die Dateiverarbeitung
# include <string>
# include <iostream>

# include "Decodieren.h"

class Lsdvd : public QObject
{
    Q_OBJECT
    private:
        QComboBox *cotitel,                      // Der uebergebene Zeiger der ComboBox  die die Auswahl der Titel anzeigt 
                  *coalang,                      // Der uebergebene Zeiger der ComboBox  die die Auswahl der Audiospur anzeigt
                  *countertitel;                 // Der uebergebene Zeiger der ComboBox  die die Auswahl der Untertitel anzeigt
 
        QString indirpfad,                       // der Ort des Eingaebordners
                aufruf,                          // stellt den aufrufstring zusammen
                sprache;                         // Welche Sprache eingestellt ist

        int position,                            // Position wo der Name der Sprache aufhoert
            debuglevel;

        bool endedatei;                          // Fuer die Kontrolle ob die Datei zu Ende ist

        string temp;                             // Temporaere Ablage der eingelesenen Zeile

        Decodieren *decodieren;                  // Der uebergebene Zeiger der Decodieren 

    public:
        Lsdvd(QComboBox *titel,QComboBox *alang,QComboBox *untertitel,Decodieren *deco,int startdebug);

        // ruft lsdvd mit den indirnamen auf 
        void aufruf_lsdvd (QString option);

    public slots:
        // Wenn ein neuer Ordner ausgweaehlt wird soll dort nach Titelinformationen gesucht werden
        void titeleinlesen (QString dirpfad);

        // Audiodaten einlesen
        void audioeinlesen (QString titel);

        // Untertitel einlesen
        void untertiteleinlesen (QString titel);

        // Den Debuglevel neu setzen
        void setDebug (int newDebug);

        // Die Sprache auf Deutsch setzen
        void setDeutsch(void);

        // Die Sprache auf English setzen
        void setEnglish(void);
};


# endif
