/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Stapelfenster.h"

# ifndef STAPELFENSTER_CPP
# define STAPELFENSTER_CPP

Stapelfenster::Stapelfenster(QWidget *parent,int poshor,int posver,Decodieren *decodieren)
{
    // Speichert das Eltern Widget ab
    eltern=parent;

    // Setzt die Groesse un Poition des Fensters
    setGeometry(poshor,posver,485,40);

    // Setze den Namen des Fensters
    //setCaption("Stapelverarbeitung dvd2xvid");

    // Den Anfangswert fuer die Zeilenvariable festlegen
    zeile=1;

    // Abgrenzungslinie bei der Ueberschrift
    QFrame *hlinie1 = new QFrame(this);
    hlinie1->setPaletteForegroundColor(Qt::lightGray);
    hlinie1->setFrameStyle(QFrame::HLine|QFrame::Plain);
    hlinie1->setLineWidth(1);
    hlinie1->setGeometry(2,19,481,1);

    // Ueberschrift erstellen
    ueber1 = new QLabel(this);
    ueber1->setGeometry(0,1,17,18);
    ueber1->setFont(QFont("SansSerif",11));

    ueber2 = new QLabel(this);
    ueber2->setGeometry(80,1,150,18);
    ueber2->setFont(QFont("SansSerif",11));

    ueber3 = new QLabel(this);
    ueber3->setGeometry(355,1,130,18);
    ueber3->setFont(QFont("SansSerif",11));

    // Mit diesen Knopf wird der Encodiervorgnag gestartet
    starten = new QPushButton("Start",this);
    starten->setFont(QFont("SansSerif",11));

    // Mit diesen Knopf wird der Encodiervorgnag gestartet
    loeschen = new QPushButton("Reset",this);
    loeschen->setFont(QFont("SansSerif",11));

    //Die Zeilen einmal erstellen
    for(int var=0;var<10;var++)
    {
        stapelzeile[var] = new Stapelzeile(this);
    }

    // Beim Drueckn vom Start Knopf sollte der Vorgang gesartete werden
    QObject::connect(starten,      SIGNAL(released()),                  decodieren,      SLOT(starten()));

    // Alle Auftraege sollen geloescht werden
    QObject::connect(loeschen,     SIGNAL(released()),                  decodieren,      SLOT(var_reset()));
    QObject::connect(loeschen,     SIGNAL(released()),                  this,            SLOT(reset()));
}

void Stapelfenster::addZeile(QString inhalt,QString titel,bool cartoon,bool pass2,bool autoaspect)
{
    // Das Fenster kurz verstecken damit beim naechsten show() Aufruf alles angezeigt werden kann
    hide();

    // Die Groesse des Fensters anpassen 
    groesse();

    // Vom Ausgabenamen den Pfadteil trennen
    inhalt.remove(0,(inhalt.findRev("/",-1,false)+1)); 

    stapelzeile[zeile]->makeZeile(inhalt,titel,0,20*zeile,zeile,cartoon,pass2,autoaspect);

    // Damit der naechste Aufruf auch in der naechsten Zeile Statt findet
    zeile++;

    // Das Fenster wieder sichtbar machen
    show();

    // Die Position des Fensters beim ersten Aufruf anpassen
    if(zeile==2)
    {
        position();
    }

    emit hinzugefuegt();
}

void Stapelfenster::reset(void)
{
    hide();

    //Die Zeilen Ausblenden
    for(int var=0;var<10;var++)
    {
        stapelzeile[var]->hideZeile();
    }

    // Zeilenvariable zuruecksetzen
    zeile=1;
}

void Stapelfenster::groesse (void)
{
    hoehe=20+(zeile*20);

    // Festlegen der Minimum und Maximumgroesse des Fensters
    setMinimumSize(485,hoehe+30);
    setMaximumSize(485,hoehe+30);

    // Die Poition des Knopfes anpassen
    starten->setGeometry(385,hoehe+2,85,25);
    loeschen->setGeometry(25,hoehe+2,85,25);
}

void Stapelfenster::position (void)
{
    QRect hauptfenster;
    hauptfenster=eltern->frameGeometry();
    move(QPoint(hauptfenster.left(),(hauptfenster.top()+418)));
}

void Stapelfenster::setDeutsch (void)
{
    // Fenster Titel auf Deutsch setzen
    setCaption("Stapelverarbeitung - dvd2xvid");

    // Ueberschriftn auf Detusch setzen
    ueber1->setText("Nr");
    ueber2->setText("Ausgabename");
    ueber3->setText("Titel Ze  2P  Au");
}

void Stapelfenster::setEnglish (void)
{
    // Fenster Titel auf Deutsch setzen
    setCaption("Batch processing - dvd2xvid");

    // Ueberschriftn auf Detusch setzen
    ueber1->setText("Nr");
    ueber2->setText("Outfile");
    ueber3->setText("title ze  2p  au");
}
#endif
