/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# ifndef STAPELFENSTER_H
# define STAPELFENSTER_H

# include <qwidget.h>
# include <qstring.h>
# include <qlabel.h>
# include <qrect.h>
# include <qpushbutton.h>

# include "Stapelzeile.h"
# include "Decodieren.h"


class Stapelfenster : public QWidget
{
    Q_OBJECT
    private:
        QWidget *eltern;                         // Darin wird der Zeiger zum Elternwidget abgelegt

        QLabel *ueber1,                          // 1 Ueberschrift = "Nr"
               *ueber2,                          // 2 Ueberschrift = "Ausgabename"
               *ueber3;                          // 3 Ueberschrift = "Titel Ze  2P  Au"

        QPushButton *starten,                    // Mit diesen Knopf soll der Encodiervorgang gestartet werden
                    *loeschen;                   // Mit deisen knopf der Staple geloescht werden

        Stapelzeile *stapelzeile[10];

        int zeile,                               // Beinhaltet die aktuelle Zeile
            hoehe;                               // Die hoehe des Fensters 

    public:
        Stapelfenster(QWidget *parent,int poshor,int posver,Decodieren *decodieren);

    signals:
        // Wird gesendet wenn das hinzufuegen der Zeile beendet ist
        void hinzugefuegt(void);

    public slots:
        // Soll einen Neue Zeile im Fenster hinzufuegen
        void addZeile(QString inhalt,QString titel,bool cartoon,bool pass2,bool autoaspect);

        // Alles zuruecksetzen
        void reset (void);

        // Die Groesse des Fensters anpassen
        void groesse (void);

        // Die Poition des Fensters am Hauptfenster ausrichten
        void position (void);

        // Sprache in Staplefenster auf Deutsch stellen
        void setDeutsch (void);

        // Sprache in Staplefenster auf English stellen
        void setEnglish (void);
};

# endif
